//+---------------------------------------------------------------------+ 
//|                                         Cronex_Impulse_CD_Color.mq5 | 
//|                                            Copyright  2007, Cronex | 
//|                                                                     | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2007, Cronex"
#property link "" 
//----   
#property version   "1.00"
//----     
#property indicator_separate_window 
//----    2
#property indicator_buffers 4 
//----     
#property indicator_plots   4
//+-----------------------------------+
//|     1 |
//+-----------------------------------+
//----     
#property indicator_type1 DRAW_HISTOGRAM
//----     MACD   MediumSlateBlue 
#property indicator_color1 clrMediumSlateBlue
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "Impulse CD XMACD"

//+-----------------------------------+
//|     2 |
//+-----------------------------------+
//----     
#property indicator_type2 DRAW_LINE
//----       Coral 
#property indicator_color2 clrCoral
//----   -  
#property indicator_style2 STYLE_SOLID
//----     1
#property indicator_width2 2
//----    
#property indicator_label2  "Impulse CD Signal Line"

//+-----------------------------------+
//|     3 |
//+-----------------------------------+
//----     
#property indicator_type3 DRAW_HISTOGRAM
//----     MACD   Lime 
#property indicator_color3 clrLime
//----     2
#property indicator_width3 2
//----   
#property indicator_label3 "Impulse CD Upper"

//+-----------------------------------+
//|     4 |
//+-----------------------------------+
//----     
#property indicator_type4 DRAW_HISTOGRAM
//----     MACD   Red 
#property indicator_color4 clrRed
//----     2
#property indicator_width4 2
//----   
#property indicator_label4 "Impulse CD Lower"


//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2,XMA3,XMA4;
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input Smooth_Method XMA_Method=MODE_T3; //  
input uint Fast_XMA = 12; //  
input uint Slow_XMA = 26; //  
input int XPhase = 100;  //  ,
                       // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
input Smooth_Method Signal_Method=MODE_JJMA; //   
input uint Signal_XMA = 9; //   
input int Signal_Phase = 100; //   ,
                     //   -100 ... +100,
//    ;
//+-----------------------------------+
//---- e 
double MACDBuffer[],SignBuffer[],UpCDDivrBuffer[],DnCDDivrBuffer[];

int min_rates_total,min_rates_; 
//+------------------------------------------------------------------+    
//| XMACD indicator initialization function                          | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_=MathMax(XMA1.GetStartBars(XMA_Method,Fast_XMA,XPhase),XMA1.GetStartBars(XMA_Method,Slow_XMA,XPhase));
   min_rates_total=min_rates_+XMA1.GetStartBars(Signal_Method,Signal_XMA,Signal_Phase)+1;
   
//----    MACDBuffer   
   SetIndexBuffer(0,MACDBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----    SignBuffer   
   SetIndexBuffer(1,SignBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   
//----    SignBuffer   
   SetIndexBuffer(2,UpCDDivrBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
   
//----    SignBuffer   
   SetIndexBuffer(3,DnCDDivrBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//----       
   XMA1.XMALengthCheck("Fast_XMA",Fast_XMA);
   XMA1.XMALengthCheck("Slow_XMA",Slow_XMA);
   XMA1.XMALengthCheck("Signal_XMA",Signal_XMA);
//----       
   XMA1.XMAPhaseCheck("XPhase",XPhase,XMA_Method);
   XMA1.XMAPhaseCheck("Signal_Phase",Signal_Phase,Signal_Method);
   
//----      
   string shortname;  
   string Smooth1=XMA1.GetString_MA_Method(XMA_Method);
   string Smooth2=XMA1.GetString_MA_Method(Signal_Method);
   StringConcatenate(shortname,"Cronex_Impulse_CD_Color(",Fast_XMA,", ",Slow_XMA,", ",Signal_XMA,", ",Smooth1,", ",Smooth2,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+  
//| XMACD iteration function                                         | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----   
   int first,bar;
//----       
   double price,fast_xma,hslow_xma,lslow_xma,xmacd,sign_xma;

//----     OnCalculate()
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=0; //      
     }
   else first=prev_calculated-1; //      

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      price=PriceSeries(PRICE_WEIGHTED,bar,open,low,high,close);
      fast_xma=XMA1.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,Fast_XMA,price,bar,false);
      hslow_xma=XMA2.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,Slow_XMA,high[bar],bar,false);
      lslow_xma=XMA3.XMASeries(0,prev_calculated,rates_total,XMA_Method,XPhase,Slow_XMA,low[bar],bar,false);
      
      xmacd=0.0;
      if(fast_xma>hslow_xma) xmacd=fast_xma-hslow_xma;     
      if(fast_xma<lslow_xma) xmacd=fast_xma-lslow_xma;  
      
      sign_xma=XMA4.XMASeries(min_rates_,prev_calculated,rates_total,Signal_Method,Signal_Phase,Signal_XMA,xmacd,bar,false);

      //----            
      MACDBuffer[bar]=xmacd;
      SignBuffer[bar]=sign_xma;
      
      if(!bar) continue;
      double res0=xmacd-sign_xma;
      double res1=MACDBuffer[bar-1]-SignBuffer[bar-1];
      DnCDDivrBuffer[bar]=UpCDDivrBuffer[bar]=EMPTY_VALUE;
      if(res0>=res1) UpCDDivrBuffer[bar]=res0;
      else DnCDDivrBuffer[bar]=res0;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
